#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
#
logfile="/var/log/userful-multiuser-device.log"
if [ ! -e /etc/usbaudio ]; then
touch /etc/usbaudio
fi
if [ "`grep -c Internal_Audio /etc/usbaudio`" = "0" ]; then  # There is no Internal_Audio string in the /etc/usbaudio file
echo "no Internal_Audio" >> $logfile
cp -f /etc/usbaudio /etc/usbaudio.old
internal_audio_assigned_station_name=`grep Internal_Audio /etc/usbaudio.old| awk '{print $3}'` 
#
sed '/Internal_Audio/d' /etc/usbaudio.old >/etc/usbaudio
conflict=0
if [ "$internal_audio_assigned_station_name" != "" ]; then
conflict=`grep -c $internal_audio_assigned_station_name /etc/usbaudio`
fi
if [ -d /opt/userful/locks ]; then
echo 1 >/opt/userful/locks/audio_bootup
fi
search_result=0
onboard_audio_alsa_device_name=""
count=0
if [ ! -d /sys/class/sound ]; then
exit 1
fi
for pcm_device_dir in `ls /sys/class/sound |grep 'pcmC.D0c'`
do
if [ -e /sys/class/sound/$pcm_device_dir/driver ]; then
search_result=`ls -l /sys/class/sound/$pcm_device_dir/driver |grep -c pci`
else
search_result=0
fi
if [ $search_result -eq 1 ]; then
onboard_audio_alsa_device_name=`echo ${pcm_device_dir:4:1}`
onboard_audio_physical_location=`ls -l /sys/class/sound/$pcm_device_dir |grep device |awk '{print substr($11,9)}'`
count=`expr $count + 1`
fi
done
if [ $count -eq 0 ]; then
echo "No internal audio found." >> $logfile
elif [ $count -eq 1 ]; then
if [ "$internal_audio_assigned_station_name" != "" ] && [ $conflict -eq 0 ]; then
echo "Internal_Audio hw:$onboard_audio_alsa_device_name $internal_audio_assigned_station_name R/W $onboard_audio_physical_location" >> \ 
/etc/usbaudio
elif [ "`cat /etc/fedora-release | awk '{print $1,$2}'`" = "Userful release" ]; then
echo "Internal_Audio hw:$onboard_audio_alsa_device_name Disabled R/W $onboard_audio_physical_location" >>/etc/usbaudio
else
echo "Internal_Audio hw:$onboard_audio_alsa_device_name Srn:0.0 R/W $onboard_audio_physical_location" >>/etc/usbaudio
fi
amixer set -c $onboard_audio_alsa_device_name Master 100 unmute
amixer set -c $onboard_audio_alsa_device_name PCM 100 unmute
amixer set -c $onboard_audio_alsa_device_name CD 100 unmute
elif [ $count -gt 1 ]; then
if [ "$onboard_audio_alsa_device_name" != "" ]; then
if [ "$internal_audio_assigned_station_name" != "" ] && [ $conflict -eq 0 ];then
echo "Internal_Audio hw:$onboard_audio_alsa_device_name $internal_audio_assigned_station_name R/W $onboard_audio_physical_location" >> \
/etc/usbaudio
else
echo "Internal_Audio hw:$onboard_audio_alsa_device_name Disabled R/W $onboard_audio_physical_location" >>/etc/usbaudio
fi
amixer set -c $onboard_audio_alsa_device_name Master 100 unmute
amixer set -c $onboard_audio_alsa_device_name PCM 100 unmute
amixer set -c $onboard_audio_alsa_device_name CD 100 unmute  
else
echo "No internal audio found."
fi

fi
fi

