#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
#
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`
if [ $# -eq 1 ]; then
CALLEDFROM="$1"
fi
source /etc/sysconfig/xtype
if [ -f /tmp/distro.conf ]; then
source /tmp/distro.conf
fi
if [ -z "$DMPAM" ]; then
DMPAM=/etc/pam.d/gdm
fi
function check_arch()
{
case $(uname -m) in
x86_64|ia64)
echo "lib64"
;;
*)
echo "lib"
;;
esac
}
LIB=$(check_arch)
if [ -z "$XTYPE" -o "$XTYPE" == "SINGLE" ]; then
if [ ! -f /opt/userful/bin/multistation-storage-config.sh -a -e $DMPAM ]; then
#
PAM_MODULE=""
PAM_MODULE=`grep "pam_console.so" $DMPAM`
if [ "$PAM_MODULE" != "" -a "${PAM_MODULE:0:1}" == "#" ]; then
NEW_PAM_MODULE=${PAM_MODULE:1}
sed -i -e "s/$PAM_MODULE/$NEW_PAM_MODULE/g" $DMPAM
fi
#
PAM_MODULE=""
PAM_MODULE=`grep "pam_devperm.so" $DMPAM`
if [ "$PAM_MODULE" != "" -a "${PAM_MODULE:0:1}" == "#" ]; then
NEW_PAM_MODULE=${PAM_MODULE:1}
sed -i -e "s/$PAM_MODULE/$NEW_PAM_MODULE/g" $DMPAM
fi
fi
if [ -f /usr/share/hal/fdi/policy/10osvendor/80-resmgr.fdi.multi-save ]; then
mv -f /usr/share/hal/fdi/policy/10osvendor/80-resmgr.fdi.multi-save /usr/share/hal/fdi/policy/10osvendor/80-resmgr.fdi
fi
if [ -f /usr/share/hal/fdi/policy/20thirdparty/99-userful-multimedia-policy.fdi ]; then #FC6
rm -f /usr/share/hal/fdi/policy/20thirdparty/99-userful-multimedia-policy.fdi
fi
if [ -f /usr/share/config/kcmartsrc ]; then
rm -f /usr/share/config/kcmartsrc
fi
if [ -f /opt/kde3/share/config/kcmartsrc ]; then
rm -f /opt/kde3/share/config/kcmartsrc
fi
echo "`date +"%b %d %T"` $ProgramName: Multi X is not enabled." >> $logfile
exit 0
fi
#
if [ -d /usr/share/hal/fdi/policy/20thirdparty ]; then #FC6, SLED10, Ubuntu 6.10
cp -f /etc/userful/setup/99-userful-multimedia-policy.fdi /usr/share/hal/fdi/policy/20thirdparty
fi
if [ -d /usr/$LIB/hal/scripts ]; then #FC6, SLED10
ln -sf /opt/userful/bin/multistation-audio-hotplug.sh /usr/$LIB/hal/scripts/multistation-audio-hotplug.sh
elif [ -d /usr/share/hal/scripts ]; then #Ubuntu 6.10
ln -sf /opt/userful/bin/multistation-audio-hotplug.sh /usr/share/hal/scripts/multistation-audio-hotplug.sh
fi
#
if [ -f /usr/share/hal/fdi/policy/10osvendor/80-resmgr.fdi ]; then
if [ ! -f /usr/share/hal/fdi/policy/10osvendor/80-resmgr.fdi.multi-save ]; then
pushd /usr/share/hal/fdi/policy/10osvendor/ > /dev/null
cp 80-resmgr.fdi 80-resmgr.fdi.multi-save
cat /etc/userful/setup/suse-resmgr-fdi.patch | patch -p0 > /dev/null 2>&1
popd > /dev/null
fi
fi
#
if [ ! -f /usr/bin/zenity ]; then
if [ -f /opt/gnome/bin/zenity ]; then
ln -s /opt/gnome/bin/zenity /usr/bin/zenity
fi
fi
#
if which aoss > /dev/null 2>&1; then
if [ -f /etc/firefox/firefoxrc ]; then
sed -i -e "s/FIREFOX_DSP=.*/FIREFOX_DSP=\"aoss\"/g" /etc/firefox/firefoxrc
fi
fi
if [ -e $DMPAM ]; then
#
PAM_MODULE=""
PAM_MODULE=`grep "pam_console.so" $DMPAM`
if [ "$PAM_MODULE" != "" -a "${PAM_MODULE:0:1}" != "#" ]; then
sed -i -e "s/$PAM_MODULE/#$PAM_MODULE/g" $DMPAM
fi
#
PAM_MODULE=""
PAM_MODULE=`grep "pam_devperm.so" $DMPAM`
if [ "$PAM_MODULE" != "" -a "${PAM_MODULE:0:1}" != "#" ]; then
sed -i -e "s/$PAM_MODULE/#$PAM_MODULE/g" $DMPAM
fi
fi
if [ -d /usr/share/config ]; then
echo "[Arts]" > /usr/share/config/kcmartsrc
echo "StartServer=false" >> /usr/share/config/kcmartsrc
fi
if [ -d /opt/kde3/share ]; then
mkdir -p /opt/kde3/share/config
echo "[Arts]" > /opt/kde3/share/config/kcmartsrc
echo "StartServer=false" >> /opt/kde3/share/config/kcmartsrc
fi
if [ "$CALLEDFROM" != "-install" ]; then
/opt/userful/bin/multistation-audio-refresh.sh
fi
