#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`
ALSA_CARD=$1
CONFIG_TYPE=$2
echo "`date +"%b %d %T"` $ProgramName: Configure audio for $CONFIG_TYPE" >> $logfile
function configure_pulse()
{
local alsa_card=$1
echo '
pcm.card0 {
type hw
card '$alsa_card'
}
pcm.sound-in {
type asym
playback.pcm "pulse"
capture.pcm "card0"
}
pcm.sound-out {
type pulse
}
pcm.ringing {
type pulse
}
pcm.!default {
type pulse
}
ctl.!default {
type pulse
}'  > ~/.asoundrc
if [ ! -d ~/.pulse ]; then
mkdir ~/.pulse
fi
echo '
#!/usr/bin/pulseaudio -nF
load-module module-alsa-sink device=hw:'$alsa_card'
load-module module-native-protocol-unix
set-sink-volume 0 45000
' > ~/.pulse/default.pa
echo '
default-fragments = 8
default-fragment-size-msec = 5
' > ~/.pulse/daemon.conf
echo '
autospawn = yes
' > ~/.pulse/client.conf
}
function configure_alsa()
{
local alsa_card=$1
echo '
pcm.!default {
type hw
card '$alsa_card'
}
ctl.!default {
type hw
card '$alsa_card'
}
pcm.dsp0 {
type plug
slave.pcm "hw:'$alsa_card',0"
}'  > ~/.asoundrc
}
if [ "$CONFIG_TYPE" == "alsa" ]; then
configure_alsa $ALSA_CARD
elif [ "$CONFIG_TYPE" == "pulse" ]; then
configure_pulse $ALSA_CARD
else
echo "`date +"%b %d %T"` $ProgramName: Invalid config type: $CONFIG_TYPE" >> $logfile
fi
