#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
#
#
#
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`
CONFIG_FILE="/etc/usbaudio"
DEFAULT_VOLUME="70%"
if [ ! -f /etc/userful/os-info ]; then
/opt/userful/bin/dm-check-os.sh
fi
source /etc/userful/os-info
SCREEN_NUM=${DISPLAY##*:}
SCREEN_NUM=${SCREEN_NUM/.*}
CUR_SCREEN_STR="Srn:$SCREEN_NUM.0" # Srn:#.0
ALSA_CARD_STR=`grep $CUR_SCREEN_STR $CONFIG_FILE | awk '{print $2}'` # hw:#
if [ -z "$ALSA_CARD_STR" ]; then
echo "`date +"%b %d %T"` $ProgramName: No audio device assigned for DISPLAY=:$SCREEN_NUM" >> $logfile
exit 1
else 
echo "`date +"%b %d %T"` $ProgramName: Session start with DISPLAY=:$SCREEN_NUM, alsa device=$ALSA_CARD_STR" >> $logfile
ALSA_CARD=`echo $ALSA_CARD_STR | sed 's/^...//g'`
amixer set -c $ALSA_CARD Master $DEFAULT_VOLUME unmute > /dev/null 2>&1  
amixer set -c $ALSA_CARD 'Master Mono' $DEFAULT_VOLUME unmute > /dev/null 2>&1
amixer set -c $ALSA_CARD Headphone $DEFAULT_VOLUME unmute > /dev/null 2>&1
amixer set -c $ALSA_CARD PCM $DEFAULT_VOLUME unmute > /dev/null 2>&1
amixer set -c $ALSA_CARD Speaker $DEFAULT_VOLUME unmute > /dev/null 2>&1
amixer set -c $ALSA_CARD 'Mic' capture 80% cap > /dev/null 2>&1
amixer set -c $ALSA_CARD 'Mic' playback 0% mute > /dev/null 2>&1
amixer set -c $ALSA_CARD 'Auto Gain Control' playback 0% mute > /dev/null 2>&1
amixer set -c $ALSA_CARD 'Capture' capture  100% cap > /dev/null 2>&1
if which pulseaudio > /dev/null 2>&1; then
/opt/userful/bin/multistation-audio-gen-conf.sh $ALSA_CARD pulse
if [ -e /etc/X11/Xsession.d/*pulseaudio -o -e /etc/xdg/autostart/pulseaudio.desktop ]; then
if `pulseaudio --check`; then
echo "`date +"%b %d %T"` $ProgramName: pulseaudio is already running. Need to restart.." >> $logfile
pulseaudio --kill
fi
else
echo "`date +"%b %d %T"` $ProgramName: Start pulseaudio manually.." >> $logfile
pulseaudio -D true --use-pid-file=true >> $logfile 2>&1
fi
else
/opt/userful/bin/multistation-audio-gen-conf.sh $ALSA_CARD alsa
fi
aplay -Dplug:default /usr/share/sounds/userful-startup.wav
fi
